"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("lodash/merge"),t=require("vue"),a=require("lodash/drop"),l=require("lodash/every"),r=require("lodash/forEach"),o=require("lodash/get"),s=require("lodash/isArray"),n=require("lodash/map"),u=require("lodash/set"),i=require("lodash/pickBy"),c=require("papaparse"),p=require("lodash/findKey"),d=require("axios");function m(e){return e&&"object"==typeof e&&"default"in e?e:{default:e}}var v=m(e),f=m(a),g=m(l),C=m(r),b=m(o),y=m(s),V=m(n),h=m(u),k=m(i),S=m(c),B=m(p),D=m(d);const I={errors:{fileRequired:"A file is required",invalidFieldType:"Invalid data type in row ${row} column ${col}. ",invalidMimeType:"Invalid file type"},toggleHeaders:"File has headers",submitBtn:"Submit",fieldColumn:"Field",csvColumn:"Column",requiredField:"*",excludeField:"Exclude field"};var E={props:{modelValue:Array,fields:{type:[Object,Array],required:!0},text:{default:()=>({})}},setup(e,{emit:a}){let l=t.reactive({errors:[],inputName:"csv",file:null,map:{},value:{},fields:(r=e.fields,y.default(r)?V.default(r,(e=>({key:e,label:e,required:!0}))):V.default(r,((e,t)=>({key:t,label:b.default(e,"label",e),required:b.default(e,"required",!0),type:b.default(e,"type",String)})))),fileHasHeaders:null,csvSample:null,rawCsv:null,language:v.default({},I,e.text),firstSampleRow:t.computed((()=>y.default(l.csvSample)&&y.default(l.csvSample[0])?l.csvSample[0]:null)),allFieldsAreMapped:t.computed((()=>g.default(l.fields,(function(e){return void 0!==l.map[e.key]||!e.required}))))});var r;const o=l.fields.reduce(((e,t)=>h.default(e,t.key,t.type??String)),{}),s=function(e,t){let a=o[e](t);if(o[e]===Boolean)switch(t.toLowerCase().trim()){case"false":case"no":case"off":case"0":case"null":case"":return!1;case"true":case"yes":case"on":case"1":return!0;default:throw"Not a boolean!"}if(Object.is(NaN,a))throw"Not a number!";return a};return t.provide("VueCsvImportData",l),t.provide("buildMappedCsv",(function(){let e=l.fileHasHeaders?l.rawCsv:f.default(l.rawCsv);l.errors=[];const t=k.default(l.map,(e=>Number.isInteger(e)));l.value=V.default(e,((e,a)=>{let r={};return C.default(t,((t,o)=>{let n=b.default(e,t);try{n=s(o,n)}catch(e){l.errors.push(I.errors.invalidFieldType.replace(/\${row}/g,a+(l.fileHasHeaders?1:2)).replace(/\${col}/g,t+1))}finally{h.default(r,o,n)}})),r})),a("update:modelValue",l.value)})),{VueCsvImportData:l}}};E.render=function(e,a,l,r,o,s){return t.renderSlot(e.$slots,"default",{errors:r.VueCsvImportData.errors,fields:r.VueCsvImportData.fields,file:r.VueCsvImportData.file})},E.__file="src/components/VueCsvImport.vue";var x={name:"VueCsvFiles",setup:()=>({VueCsvImportData:t.inject("VueCsvImportData")})};x.render=function(e,a,l,r,o,s){return t.renderSlot(e.$slots,"default",{errors:r.VueCsvImportData.errors.value},(()=>[(t.openBlock(!0),t.createElementBlock(t.Fragment,null,t.renderList(r.VueCsvImportData.errors,(a=>(t.openBlock(),t.createElementBlock("span",t.normalizeProps(t.guardReactiveProps(e.$attrs)),t.toDisplayString(a),17)))),256))]))},x.__file="src/components/VueCsvErrors.vue";const w={"text/csv":{source:"iana",compressible:!0,extensions:["csv"]},"application/vnd.ms-excel":{source:"iana",compressible:!1,extensions:["xls","xlm","xla","xlc","xlt","xlw"]},"text/plain":{source:"iana",compressible:!0,extensions:["txt","text","conf","def","list","log","in","ini"]}};var H={name:"CsvFile",props:{name:{type:String,default:"csv"},headers:{type:[Boolean,null],default:!0},parseConfig:{type:Object,default:()=>({})},validation:{type:Boolean,default:!0},fileMimeTypes:{type:Array,default:()=>["text/csv","text/x-csv","application/vnd.ms-excel","text/plain"]}},setup(e){const a=t.ref(null),l=t.inject("VueCsvImportData"),r=t.inject("buildMappedCsv"),o=l.language;l.inputName=name,l.fileHasHeaders=null!==e.headers?!!e.headers:null;const s=function(t){if(l.errors=[],t||l.errors.push(o.errors.fileRequired),e.validation){const a=""===t.type?function(e){if(!e||"string"!=typeof e)return!1;let t=e.split(".").pop();return t&&B.default(w,(e=>e.extensions.includes(t)))||!1}(t.name):t.type;return e.fileMimeTypes.includes(a)||l.errors.push(o.errors.invalidMimeType),0===l.errors.length}return!0};return t.watch((()=>l.file),(t=>{t||(l.csvSample.value=null,l.rawCsv.value=null);let a=new FileReader;a.readAsText(l.file,e.parseConfig.encoding||"UTF-8"),a.onload=function(t){l.csvSample=b.default(S.default.parse(t.target.result,v.default({preview:10,skipEmptyLines:!0},e.parseConfig)),"data"),l.rawCsv=b.default(S.default.parse(t.target.result,v.default({skipEmptyLines:!0},e.parseConfig)),"data")},a.onerror=function(e){console.log(e)}}),{deep:!0}),t.watch((()=>l.fileHasHeaders),(()=>{l.allFieldsAreMapped&&r()})),{file:l.file,change:function(){let e=a.value.files?a.value.files[0]:null;s(e)&&(l.file=e)},csvRef:a}}};const M=["name"];H.render=function(e,a,l,r,o,s){return t.renderSlot(e.$slots,"default",{file:r.file,change:r.change},(()=>[t.createElementVNode("input",t.mergeProps({ref:"csvRef",type:"file",onChange:a[0]||(a[0]=(...e)=>r.change&&r.change(...e)),name:l.name},e.$attrs),null,16,M)]))},H.__file="src/components/VueCsvInput.vue";var N={name:"CsvMap",props:{noThead:{type:Boolean,default:!1},selectAttributes:{type:Object,default:()=>({})},autoMatch:{type:Boolean,default:!0},autoMatchIgnoreCase:{type:Boolean,default:!0}},setup(e){const a=t.inject("VueCsvImportData"),l=t.inject("buildMappedCsv"),r=a.language;return t.watch((()=>a.map),(function(){a.allFieldsAreMapped&&l()}),{deep:!0}),e.autoMatch&&t.watch((()=>a.csvSample),(function(t){t&&a.fields.forEach((l=>{t[0].forEach(((t,r)=>{(e.autoMatchIgnoreCase?l.label.toLowerCase().trim():l.label.trim())===(e.autoMatchIgnoreCase?t.toLowerCase().trim():t.trim())&&(a.map[l.key]=r)}))}))})),{VueCsvImportData:a,labels:r}}};const q={key:0},F=["name","onUpdate:modelValue"],_={key:0,value:null},j=["value"];N.render=function(e,a,l,r,o,s){return t.renderSlot(e.$slots,"default",{sample:r.VueCsvImportData.firstSampleRow,map:r.VueCsvImportData.map,fields:r.VueCsvImportData.fields},(()=>[r.VueCsvImportData.firstSampleRow?(t.openBlock(),t.createElementBlock("table",t.normalizeProps(t.mergeProps({key:0},e.$attrs)),[l.noThead?t.createCommentVNode("v-if",!0):(t.openBlock(),t.createElementBlock("thead",q,[t.createElementVNode("tr",null,[t.createElementVNode("th",null,t.toDisplayString(r.labels.fieldColumn),1),t.createElementVNode("th",null,t.toDisplayString(r.labels.csvColumn),1)])])),t.createElementVNode("tbody",null,[(t.openBlock(!0),t.createElementBlock(t.Fragment,null,t.renderList(r.VueCsvImportData.fields,((e,a)=>(t.openBlock(),t.createElementBlock("tr",{key:a},[t.createElementVNode("td",null,t.toDisplayString(e.label),1),t.createElementVNode("td",null,[t.withDirectives(t.createElementVNode("select",t.mergeProps(l.selectAttributes,{name:`csv_uploader_map_${a}`,"onUpdate:modelValue":t=>r.VueCsvImportData.map[e.key]=t}),[e.required?t.createCommentVNode("v-if",!0):(t.openBlock(),t.createElementBlock("option",_," ")),(t.openBlock(!0),t.createElementBlock(t.Fragment,null,t.renderList(r.VueCsvImportData.firstSampleRow,((e,a)=>(t.openBlock(),t.createElementBlock("option",{key:a,value:a},t.toDisplayString(e),9,j)))),128))],16,F),[[t.vModelSelect,r.VueCsvImportData.map[e.key]]])])])))),128))])],16)):t.createCommentVNode("v-if",!0)]))},N.__file="src/components/VueCsvMap.vue";var A={name:"CsvTableMap",props:{tableAttributes:{type:Object,default:()=>({})},autoMatch:{type:Boolean,default:!0},autoMatchIgnoreCase:{type:Boolean,default:!0}},setup(e){const a=t.inject("VueCsvImportData"),l=t.inject("buildMappedCsv"),r=a.language,o=t.reactive({}),s=t.computed((()=>a.fields.map((e=>(e.selected=Object.values(o).includes(e.label),e)))));t.watch((()=>o),(function(){a.map={};for(const[e,t]of Object.entries(o))""!==t&&(a.map[t.toLowerCase()]=e);a.allFieldsAreMapped&&l()}),{deep:!0});const n=t.computed((()=>a.fileHasHeaders?a.csvSample:a.csvSample.slice(1))),u=t.computed((()=>a.fileHasHeaders?[...Array(a.firstSampleRow.length).keys()].map((e=>`${r.csvColumn} ${e}`)):a.firstSampleRow));return e.autoMatch&&t.watch((()=>a.csvSample),(function(t){t&&a.fields.forEach((a=>{t[0].forEach(((t,l)=>{(e.autoMatchIgnoreCase?a.label.toLowerCase().trim():a.label.trim())===(e.autoMatchIgnoreCase?t.toLowerCase().trim():t.trim())&&(o[l]=a.label)}))}))})),{availableFields:s,csvMap:o,csvSample:n,headers:u,VueCsvImportData:a,labels:r}}};const $=["onUpdate:modelValue","name"],T={value:""},L=["value","disabled"],R=["value"];A.render=function(e,a,l,r,o,s){return t.renderSlot(e.$slots,"default",{sample:r.VueCsvImportData.firstSampleRow,map:r.VueCsvImportData.map,fields:r.VueCsvImportData.fields},(()=>[r.VueCsvImportData.firstSampleRow?(t.openBlock(),t.createElementBlock("table",t.normalizeProps(t.mergeProps({key:0},l.tableAttributes)),[t.createElementVNode("thead",null,[t.createElementVNode("tr",null,[(t.openBlock(!0),t.createElementBlock(t.Fragment,null,t.renderList(r.headers,((e,a)=>(t.openBlock(),t.createElementBlock("td",{key:e},[t.createTextVNode(t.toDisplayString(e)+" ",1),t.withDirectives(t.createElementVNode("select",{"onUpdate:modelValue":e=>r.csvMap[a]=e,name:`csv_uploader_map_${a}`,required:""},[t.createElementVNode("option",T,t.toDisplayString(r.labels.excludeField),1),(t.openBlock(!0),t.createElementBlock(t.Fragment,null,t.renderList(r.availableFields,(e=>(t.openBlock(),t.createElementBlock("option",{value:e.label,key:e.key,disabled:e.selected},t.toDisplayString(e.label)+t.toDisplayString(e.required?r.labels.requiredField:""),9,L)))),128)),r.VueCsvImportData.fields.map((e=>e.label)).includes(e)?t.createCommentVNode("v-if",!0):(t.openBlock(),t.createElementBlock("option",{value:e,key:e},t.toDisplayString(e),9,R))],8,$),[[t.vModelSelect,r.csvMap[a]]])])))),128))])]),t.createElementVNode("tbody",null,[(t.openBlock(!0),t.createElementBlock(t.Fragment,null,t.renderList(r.csvSample,(e=>(t.openBlock(),t.createElementBlock("tr",null,[(t.openBlock(!0),t.createElementBlock(t.Fragment,null,t.renderList(e,(e=>(t.openBlock(),t.createElementBlock("td",null,t.toDisplayString(e),1)))),256))])))),256))])],16)):t.createCommentVNode("v-if",!0)]))},A.__file="src/components/VueCsvTableMap.vue";var P={name:"VueCsvImportSubmit",props:{url:{type:String,required:!0},config:{type:Object,required:!1,default:{}}},setup(e){const a=t.inject("VueCsvImportData"),l=t.inject("buildMappedCsv"),r=a.language;return{submit:function(){l(),D.default.post(e.url,{[a.inputName]:a.value},e.config).then((e=>{emit("send-success",e)})).catch((e=>{emit("send-error",e)})).finally((e=>{emit("send-complete",e)}))},VueCsvImportData:a,labels:r}}};P.render=function(e,a,l,r,o,s){return t.renderSlot(e.$slots,"submit",{submit:r.submit,mappedCsv:r.VueCsvImportData.value},(()=>[t.createElementVNode("button",t.mergeProps({type:"submit"},e.$attrs,{onClick:a[0]||(a[0]=t.withModifiers(((...e)=>r.submit&&r.submit(...e)),["prevent"]))}),t.toDisplayString(r.labels.submitBtn),17)]))},P.__file="src/components/VueCsvSubmit.vue";var O={name:"ToggleHasHeaders",props:{labelAttributes:{},checkboxAttributes:{}},setup(){const e=t.inject("VueCsvImportData"),a=e.language;return{VueCsvImportData:e,toggleHasHeaders:function(){e.fileHasHeaders=!e.fileHasHeaders},labels:a}}};const U=["value"];O.render=function(e,a,l,r,o,s){return t.renderSlot(e.$slots,"default",{hasHeaders:r.VueCsvImportData.fileHasHeaders,toggle:r.toggleHasHeaders},(()=>[t.createElementVNode("label",t.normalizeProps(t.guardReactiveProps(l.labelAttributes)),[t.createElementVNode("input",t.mergeProps({type:"checkbox"},l.checkboxAttributes,{value:r.VueCsvImportData.fileHasHeaders,onChange:a[0]||(a[0]=(...e)=>r.toggleHasHeaders&&r.toggleHasHeaders(...e))}),null,16,U),t.createTextVNode(" "+t.toDisplayString(r.labels.toggleHeaders),1)],16)]))},O.__file="src/components/VueCsvToggleHeaders.vue";const z={install(e,t){t=v.default({components:{"vue-csv-import":"vue-csv-import","vue-csv-errors":"vue-csv-errors","vue-csv-input":"vue-csv-input","vue-csv-map":"vue-csv-map","vue-csv-table-map":"vue-csv-table-map","vue-csv-submit":"vue-csv-submit","vue-csv-toggle-headers":"vue-csv-toggle-headers"}},t),e.component(t.components["vue-csv-import"],E),e.component(t.components["vue-csv-errors"],x),e.component(t.components["vue-csv-input"],H),e.component(t.components["vue-csv-map"],N),e.component(t.components["vue-csv-table-map"],A),e.component(t.components["vue-csv-submit"],P),e.component(t.components["vue-csv-toggle-headers"],O)}};exports.VueCsvErrors=x,exports.VueCsvImport=E,exports.VueCsvImportPlugin=z,exports.VueCsvInput=H,exports.VueCsvMap=N,exports.VueCsvSubmit=P,exports.VueCsvTableMap=A,exports.VueCsvToggleHeaders=O;
